org.bdgenomics.adam.rdd.fragment

# ParquetUnboundFragmentRDD

#### case class ParquetUnboundFragmentRDD extends FragmentRDD with Product with Serializable

Linear Supertypes
Product, Equals, FragmentRDD, AvroRecordGroupGenomicRDD[Fragment, Fragment, FragmentRDD], GenomicRDDWithLineage[Fragment, FragmentRDD], AvroGenomicRDD[Fragment, Fragment, FragmentRDD], GenomicDataset[Fragment, Fragment, FragmentRDD], GenomicRDD[Fragment, FragmentRDD], ADAMRDDFunctions[Fragment], Logging, Serializable, Serializable, AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. ParquetUnboundFragmentRDD
2. Product
3. Equals
4. FragmentRDD
5. AvroRecordGroupGenomicRDD
6. GenomicRDDWithLineage
7. AvroGenomicRDD
8. GenomicDataset
9. GenomicRDD
10. ADAMRDDFunctions
11. Logging
12. Serializable
13. Serializable
14. AnyRef
15. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Definition Classes
     Any

3. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

4. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     Any

6. #### def addProcessingStep(newProcessingStep: ProcessingStep): FragmentRDD

   Merges a new processing record with the extant computational lineage.

   Merges a new processing record with the extant computational lineage.

   newProcessingStep
   returns

     Returns a new GenomicRDD with new record groups merged in.

   Definition Classes
     GenomicRDDWithLineage

7. #### def addRecordGroup(recordGroupToAdd: RecordGroup): FragmentRDD

   Adds a single record group to the extant record groups.

   Adds a single record group to the extant record groups.

   recordGroupToAdd

     The record group to append to the extant record groups.

   returns

     Returns a new GenomicRDD with the new record group added.

   Definition Classes
     AvroRecordGroupGenomicRDD

8. #### def addRecordGroups(recordGroupsToAdd: RecordGroupDictionary): FragmentRDD

   Merges a new set of record groups with the extant record groups.

   Merges a new set of record groups with the extant record groups.

   recordGroupsToAdd

     The record group dictionary to append to the extant record groups.

   returns

     Returns a new GenomicRDD with new record groups merged in.

   Definition Classes
     AvroRecordGroupGenomicRDD

9. #### def addSequence(sequenceToAdd: SequenceRecord): FragmentRDD

   Appends metadata for a single sequence to the current RDD.

   Appends metadata for a single sequence to the current RDD.

   sequenceToAdd

     The sequence to add.

   returns

     Returns a new GenomicRDD with this sequence appended.

   Definition Classes
     GenomicRDD

10. #### def addSequences(sequencesToAdd: SequenceDictionary): FragmentRDD

    Appends sequence metadata to the current RDD.

    Appends sequence metadata to the current RDD.

    sequencesToAdd

      The new sequences to append.

    returns

      Returns a new GenomicRDD with the sequences appended.

    Definition Classes
      GenomicRDD

11. #### final def asInstanceOf[T0]: T0

    Definition Classes
      Any

12. #### def binQualityScores(bins: Seq[QualityScoreBin]): FragmentRDD

    Rewrites the quality scores of fragments to place all quality scores in bins.

    Rewrites the quality scores of fragments to place all quality scores in bins.

    Quality score binning maps all quality scores to a limited number of discrete values, thus reducing the entropy of the quality score distribution, and reducing the amount of space that fragments consume on disk.

    bins

      The bins to use.

    returns

      Fragments whose quality scores are binned.

    Definition Classes
      FragmentRDD

13. #### def broadcast()(implicit tTag: ClassTag[Fragment]): Broadcast[IntervalArray[ReferenceRegion, Fragment]]

    Definition Classes
      GenomicRDD

14. #### def broadcastRegionJoin[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], txTag: ClassTag[(Fragment, X)]): GenericGenomicRDD[(Fragment, X)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicRDD
    See also

      broadcastRegionJoinAgainst

15. #### def broadcastRegionJoin[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y], flankSize: Long)(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], txTag: ClassTag[(Fragment, X)]): GenericGenomicRDD[(Fragment, X)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicRDD
    See also

      broadcastRegionJoinAgainst

16. #### def broadcastRegionJoinAgainst[X](broadcastTree: Broadcast[IntervalArray[ReferenceRegion, X]])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X]): GenericGenomicRDD[(X, Fragment)]

    Performs a broadcast inner join between this RDD and data that has been broadcast.

    Performs a broadcast inner join between this RDD and data that has been broadcast.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

    broadcastTree

      The data on the left side of the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicRDD
    Note

      This function differs from other region joins as it treats the calling RDD as the right side of the join, and not the left.

    See also

      broadcastRegionJoin

17. #### def broadcastRegionJoinAgainstAndGroupByRight[X, Y <: GenomicRDD[X, Y]](broadcastTree: Broadcast[IntervalArray[ReferenceRegion, X]])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X]): GenericGenomicRDD[(Iterable[X], Fragment)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

    broadcastTree

      The data on the left side of the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicRDD
    Note

      This function differs from other region joins as it treats the calling RDD as the right side of the join, and not the left.

    See also

      broadcastRegionJoinAndGroupByRight

18. #### def broadcastRegionJoinAndGroupByRight[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[Fragment], X)]): GenericGenomicRDD[(Iterable[Fragment], X)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicRDD
    See also

      broadcastRegionJoinAgainstAndGroupByRight

19. #### def broadcastRegionJoinAndGroupByRight[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y], flankSize: Long)(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[Fragment], X)]): GenericGenomicRDD[(Iterable[Fragment], X)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicRDD
    See also

      broadcastRegionJoinAgainstAndGroupByRight

20. #### def buildTree(rdd: RDD[(ReferenceRegion, Fragment)])(implicit tTag: ClassTag[Fragment]): IntervalArray[ReferenceRegion, Fragment]

    Attributes
      protected
    Definition Classes
      FragmentRDD → GenomicRDD

21. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

22. #### lazy val dataset: Dataset[Fragment]

    Definition Classes
      ParquetUnboundFragmentRDD → GenomicDataset

23. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

24. #### def filterByOverlappingRegion(query: ReferenceRegion): FragmentRDD

    Runs a filter that selects data in the underlying RDD that overlaps a single genomic region.

    Runs a filter that selects data in the underlying RDD that overlaps a single genomic region.

    query

      The region to query for.

    returns

      Returns a new GenomicRDD containing only data that overlaps the query region.

    Definition Classes
      GenomicRDD

25. #### def filterByOverlappingRegions(querys: Iterable[ReferenceRegion]): FragmentRDD

    Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    querys

      The regions to query for.

    returns

      Returns a new GenomicRDD containing only data that overlaps the querys region.

    Definition Classes
      GenomicRDD

26. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

27. #### def flattenRddByRegions(): RDD[(ReferenceRegion, Fragment)]

    Attributes
      protected
    Definition Classes
      GenomicRDD

28. #### def fullOuterShuffleRegionJoin[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], otoxTag: ClassTag[(Option[Fragment], Option[X])]): GenericGenomicRDD[(Option[Fragment], Option[X])]

    Performs a sort-merge full outer join between this RDD and another RDD.

    Performs a sort-merge full outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either RDD does not overlap any values in the other RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicRDD

29. #### def fullOuterShuffleRegionJoin[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y], flankSize: Long)(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], otoxTag: ClassTag[(Option[Fragment], Option[X])]): GenericGenomicRDD[(Option[Fragment], Option[X])]

    Performs a sort-merge full outer join between this RDD and another RDD.

    Performs a sort-merge full outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either RDD does not overlap any values in the other RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicRDD

30. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

31. #### def getReferenceRegions(elem: Fragment): Seq[ReferenceRegion]

    Returns the regions that this fragment covers.

    Returns the regions that this fragment covers.

    Since a fragment may be chimeric or multi-mapped, we do not try to compute the hull of the underlying element.

    elem

      The Fragment to get the region from.

    returns

      Returns all regions covered by this fragment.

    Attributes
      protected
    Definition Classes
      FragmentRDD → GenomicRDD

32. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

33. #### def isSorted: Boolean

    Definition Classes
      GenomicRDD

34. #### def isTraceEnabled(): Boolean

    Attributes
      protected
    Definition Classes
      Logging

35. #### lazy val jrdd: JavaRDD[Fragment]

    The underlying RDD of genomic data, as a JavaRDD.

    The underlying RDD of genomic data, as a JavaRDD.

    Definition Classes
      GenomicRDD

36. #### def leftOuterShuffleRegionJoin[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], toxTag: ClassTag[(Fragment, Option[X])]): GenericGenomicRDD[(Fragment, Option[X])]

    Performs a sort-merge left outer join between this RDD and another RDD.

    Performs a sort-merge left outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicRDD

37. #### def leftOuterShuffleRegionJoin[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y], flankSize: Long)(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], toxTag: ClassTag[(Fragment, Option[X])]): GenericGenomicRDD[(Fragment, Option[X])]

    Performs a sort-merge left outer join between this RDD and another RDD.

    Performs a sort-merge left outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicRDD

38. #### def leftOuterShuffleRegionJoinAndGroupByLeft[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], toxTag: ClassTag[(Fragment, Iterable[X])]): GenericGenomicRDD[(Fragment, Iterable[X])]

    Performs a sort-merge left outer join between this RDD and another RDD, followed by a groupBy on the left value.

    Performs a sort-merge left outer join between this RDD and another RDD, followed by a groupBy on the left value.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with an empty Iterable in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicRDD

39. #### def leftOuterShuffleRegionJoinAndGroupByLeft[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y], flankSize: Long)(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], toxTag: ClassTag[(Fragment, Iterable[X])]): GenericGenomicRDD[(Fragment, Iterable[X])]

    Performs a sort-merge left outer join between this RDD and another RDD, followed by a groupBy on the left value.

    Performs a sort-merge left outer join between this RDD and another RDD, followed by a groupBy on the left value.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with an empty Iterable in the product of the join.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicRDD

40. #### def log: Logger

    Attributes
      protected
    Definition Classes
      Logging

41. #### def logDebug(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

42. #### def logDebug(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

43. #### def logError(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

44. #### def logError(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

45. #### def logInfo(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

46. #### def logInfo(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

47. #### def logName: String

    Attributes
      protected
    Definition Classes
      Logging

48. #### def logTrace(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

49. #### def logTrace(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

50. #### def logWarning(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

51. #### def logWarning(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

52. #### def markDuplicates(): FragmentRDD

    Marks reads as possible fragment duplicates.

    Marks reads as possible fragment duplicates.

    returns

      A new RDD where reads have the duplicate read flag set. Duplicate reads are NOT filtered out.

    Definition Classes
      FragmentRDD

53. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

54. #### final def notify(): Unit

    Definition Classes
      AnyRef

55. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

56. #### lazy val optPartitionMap: Option[Array[Option[(ReferenceRegion, ReferenceRegion)]]]

    Attributes
      protected
    Definition Classes
      ParquetUnboundFragmentRDD → GenomicRDD

57. #### def pipe[X, Y <: GenomicRDD[X, Y], V <: InFormatter[Fragment, FragmentRDD, V]](cmd: String, files: List[String], environment: Map[String, String], flankSize: Integer, tFormatter: Class[V], xFormatter: OutFormatter[X], convFn: Function2[FragmentRDD, RDD[X], Y]): Y

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    Java/PySpark friendly variant.

    X

      The type of the record created by the piped command.

    Y

      A GenomicRDD containing X's.

    V

      The InFormatter to use for formatting the data being piped to the command.

    cmd

      Command to run.

    files

      Files to make locally available to the commands being run. Default is empty.

    environment

      A map containing environment variable/value pairs to set in the environment for the newly created process. Default is empty.

    flankSize

      Number of bases to flank each command invocation by.

    tFormatter

      Class of formatter for data going into pipe command.

    xFormatter

      Formatter for data coming out of the pipe command.

    convFn

      The conversion function used to build the final RDD.

    returns

      Returns a new GenomicRDD of type Y.

    Definition Classes
      GenomicRDD

58. #### def pipe[X, Y <: GenomicRDD[X, Y], V <: InFormatter[Fragment, FragmentRDD, V]](cmd: String, files: Seq[Any], environment: Map[Any, Any], flankSize: Double, tFormatter: Class[V], xFormatter: OutFormatter[X], convFn: Function2[FragmentRDD, RDD[X], Y]): Y

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    SparkR friendly variant.

    X

      The type of the record created by the piped command.

    Y

      A GenomicRDD containing X's.

    V

      The InFormatter to use for formatting the data being piped to the command.

    cmd

      Command to run.

    files

      Files to make locally available to the commands being run. Default is empty.

    environment

      A map containing environment variable/value pairs to set in the environment for the newly created process. Default is empty.

    flankSize

      Number of bases to flank each command invocation by.

    tFormatter

      Class of formatter for data going into pipe command.

    xFormatter

      Formatter for data coming out of the pipe command.

    convFn

      The conversion function used to build the final RDD.

    returns

      Returns a new GenomicRDD of type Y.

    Definition Classes
      GenomicRDD

59. #### def pipe[X, Y <: GenomicRDD[X, Y], V <: InFormatter[Fragment, FragmentRDD, V]](cmd: String, files: Seq[String] = Seq.empty, environment: Map[String, String] = Map.empty, flankSize: Int = 0)(implicit tFormatterCompanion: InFormatterCompanion[Fragment, FragmentRDD, V], xFormatter: OutFormatter[X], convFn: (FragmentRDD, RDD[X]) ⇒ Y, tManifest: ClassTag[Fragment], xManifest: ClassTag[X]): Y

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    Files are substituted in to the command with a $x syntax. E.g., to invoke a command that uses the first file from the files Seq, use $0. To access the path to the directory where the files are copied, use $root.

    Pipes require the presence of an InFormatterCompanion and an OutFormatter as implicit values. The InFormatterCompanion should be a singleton whose apply method builds an InFormatter given a specific type of GenomicRDD. The implicit InFormatterCompanion yields an InFormatter which is used to format the input to the pipe, and the implicit OutFormatter is used to parse the output from the pipe.

    X

      The type of the record created by the piped command.

    Y

      A GenomicRDD containing X's.

    V

      The InFormatter to use for formatting the data being piped to the command.

    cmd

      Command to run.

    files

      Files to make locally available to the commands being run. Default is empty.

    environment

      A map containing environment variable/value pairs to set in the environment for the newly created process. Default is empty.

    flankSize

      Number of bases to flank each command invocation by.

    returns

      Returns a new GenomicRDD of type Y.

    Definition Classes
      GenomicRDD

60. #### val processingSteps: Seq[ProcessingStep]

    The processing steps that have been applied to this GenomicRDD.

    The processing steps that have been applied to this GenomicRDD.

    Definition Classes
      ParquetUnboundFragmentRDD → GenomicRDDWithLineage

61. #### lazy val rdd: RDD[Fragment]

    Definition Classes
      ParquetUnboundFragmentRDD → GenomicRDD → ADAMRDDFunctions

62. #### val recordGroups: RecordGroupDictionary

    A dictionary describing the record groups attached to this GenomicRDD.

    A dictionary describing the record groups attached to this GenomicRDD.

    Definition Classes
      ParquetUnboundFragmentRDD → AvroRecordGroupGenomicRDD

63. #### def replaceProcessingSteps(newProcessingSteps: Seq[ProcessingStep]): FragmentRDD

    Replaces the processing steps attached to this RDD.

    Replaces the processing steps attached to this RDD.

    newProcessingSteps

      The new processing steps to attach to this RDD.

    returns

      Returns a new GenomicRDD with new processing lineage attached.

    Definition Classes
      ParquetUnboundFragmentRDD → GenomicRDDWithLineage

64. #### def replaceRdd(newRdd: RDD[Fragment], newPartitionMap: Option[Array[Option[(ReferenceRegion, ReferenceRegion)]]] = None): FragmentRDD

    Replaces the underlying RDD with a new RDD.

    Replaces the underlying RDD with a new RDD.

    newRdd

      The RDD to replace our underlying RDD with.

    returns

      Returns a new FragmentRDD where the underlying RDD has been swapped out.

    Attributes
      protected
    Definition Classes
      FragmentRDD → GenomicRDD

65. #### def replaceRecordGroups(newRecordGroups: RecordGroupDictionary): FragmentRDD

    Replaces the record groups attached to this RDD.

    Replaces the record groups attached to this RDD.

    newRecordGroups

      The new record group dictionary to attach.

    returns

      Returns a new GenomicRDD with new record groups attached.

    Definition Classes
      ParquetUnboundFragmentRDD → AvroRecordGroupGenomicRDD

66. #### def replaceSequences(newSequences: SequenceDictionary): FragmentRDD

    Replaces the sequence dictionary attached to a GenomicRDD.

    Replaces the sequence dictionary attached to a GenomicRDD.

    newSequences

      The new sequence dictionary to attach.

    returns

      Returns a new GenomicRDD with the sequences replaced.

    Definition Classes
      ParquetUnboundFragmentRDD → GenomicRDD

67. #### def rightOuterBroadcastRegionJoin[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], otxTag: ClassTag[(Option[Fragment], X)]): GenericGenomicRDD[(Option[Fragment], X)]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicRDD
    See also

      rightOuterBroadcastRegionJoin

68. #### def rightOuterBroadcastRegionJoin[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y], flankSize: Long)(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], otxTag: ClassTag[(Option[Fragment], X)]): GenericGenomicRDD[(Option[Fragment], X)]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicRDD
    See also

      rightOuterBroadcastRegionJoin

69. #### def rightOuterBroadcastRegionJoinAgainst[X](broadcastTree: Broadcast[IntervalArray[ReferenceRegion, X]])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X]): GenericGenomicRDD[(Option[X], Fragment)]

    Performs a broadcast right outer join between this RDD and data that has been broadcast.

    Performs a broadcast right outer join between this RDD and data that has been broadcast.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left table that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left table, it will be paired with a `None` in the product of the join. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

    broadcastTree

      The data on the left side of the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicRDD
    Note

      This function differs from other region joins as it treats the calling RDD as the right side of the join, and not the left.

    See also

      rightOuterBroadcastRegionJoin

70. #### def rightOuterBroadcastRegionJoinAgainstAndGroupByRight[X, Y <: GenomicRDD[X, Y]](broadcastTree: Broadcast[IntervalArray[ReferenceRegion, X]])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X]): GenericGenomicRDD[(Iterable[X], Fragment)]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left table that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left table, it will be paired with a `None` in the product of the join. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

    broadcastTree

      The data on the left side of the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicRDD
    Note

      This function differs from other region joins as it treats the calling RDD as the right side of the join, and not the left.

    See also

      rightOuterBroadcastRegionJoinAndGroupByRight

71. #### def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[Fragment], X)]): GenericGenomicRDD[(Iterable[Fragment], X)]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicRDD
    See also

      rightOuterBroadcastRegionJoinAgainstAndGroupByRight

72. #### def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y], flankSize: Long)(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[Fragment], X)]): GenericGenomicRDD[(Iterable[Fragment], X)]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicRDD
    See also

      rightOuterBroadcastRegionJoinAgainstAndGroupByRight

73. #### def rightOuterShuffleRegionJoin[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], otxTag: ClassTag[(Option[Fragment], X)]): GenericGenomicRDD[(Option[Fragment], X)]

    Performs a sort-merge right outer join between this RDD and another RDD.

    Performs a sort-merge right outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicRDD

74. #### def rightOuterShuffleRegionJoin[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y], flankSize: Long)(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], otxTag: ClassTag[(Option[Fragment], X)]): GenericGenomicRDD[(Option[Fragment], X)]

    Performs a sort-merge right outer join between this RDD and another RDD.

    Performs a sort-merge right outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicRDD

75. #### def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], otixTag: ClassTag[(Option[Fragment], Iterable[X])]): GenericGenomicRDD[(Option[Fragment], Iterable[X])]

    Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

    Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the RDD. Since this is a right outer join, all values from the right RDD who did not overlap a value from the left RDD are placed into a length-1 Iterable with a `None` key.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD, and all values from the right RDD that did not overlap an item in the left RDD.

    Definition Classes
      GenomicRDD

76. #### def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y], flankSize: Long)(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], otixTag: ClassTag[(Option[Fragment], Iterable[X])]): GenericGenomicRDD[(Option[Fragment], Iterable[X])]

    Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

    Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the RDD. Since this is a right outer join, all values from the right RDD who did not overlap a value from the left RDD are placed into a length-1 Iterable with a `None` key.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD, and all values from the right RDD that did not overlap an item in the left RDD.

    Definition Classes
      GenomicRDD

77. #### def save(filePath: String): Unit

    Saves Fragments to Parquet.

    Saves Fragments to Parquet.

    filePath

      Path to save fragments at.

    Definition Classes
      FragmentRDD

78. #### def saveAsParquet(filePath: String): Unit

    Saves this RDD to disk as a Parquet file.

    Saves this RDD to disk as a Parquet file.

    filePath

      Path to save the file at.

    Definition Classes
      AvroGenomicRDD

79. #### def saveAsParquet(filePath: String, blockSize: Integer, pageSize: Integer, compressCodec: CompressionCodecName, disableDictionaryEncoding: Boolean): Unit

    Saves this RDD to disk as a Parquet file.

    Saves this RDD to disk as a Parquet file.

    filePath

      Path to save the file at.

    blockSize

      Size per block.

    pageSize

      Size per page.

    compressCodec

      Name of the compression codec to use.

    disableDictionaryEncoding

      Whether or not to disable bit-packing.

    Definition Classes
      AvroGenomicRDD

80. #### def saveAsParquet(filePath: String, blockSize: Int = 128 * 1024 * 1024, pageSize: Int = 1 * 1024 * 1024, compressCodec: CompressionCodecName = CompressionCodecName.GZIP, disableDictionaryEncoding: Boolean = false): Unit

    Saves this RDD to disk as a Parquet file.

    Saves this RDD to disk as a Parquet file.

    filePath

      Path to save the file at.

    blockSize

      Size per block.

    pageSize

      Size per page.

    compressCodec

      Name of the compression codec to use.

    disableDictionaryEncoding

      Whether or not to disable bit-packing. Default is false.

    Definition Classes
      AvroGenomicRDD

81. #### def saveAsParquet(args: SaveArgs): Unit

    Saves RDD as a directory of Parquet files.

    Saves RDD as a directory of Parquet files.

    The RDD is written as a directory of Parquet files, with Parquet configuration described by the input param args. The provided sequence dictionary is written at args.outputPath/_seqdict.avro as Avro binary.

    args

      Save configuration arguments.

    Definition Classes
      AvroGenomicRDD

82. #### def saveAvro[U <: SpecificRecordBase](pathName: String, sc: SparkContext, schema: Schema, avro: Seq[U])(implicit tUag: ClassTag[U]): Unit

    Saves Avro data to a Hadoop file system.

    Saves Avro data to a Hadoop file system.

    This method uses a SparkContext to identify our underlying file system, which we then save to.

    Frustratingly enough, although all records generated by the Avro IDL compiler have a static SCHEMA$ field, this field does not belong to the SpecificRecordBase abstract class, or the SpecificRecord interface. As such, we must force the user to pass in the schema.

    U

      The type of the specific record we are saving.

    pathName

      Path to save records to.

    sc

      SparkContext used for identifying underlying file system.

    schema

      Schema of records we are saving.

    avro

      Seq of records we are saving.

    Attributes
      protected
    Definition Classes
      ADAMRDDFunctions

83. #### def saveMetadata(filePath: String): Unit

    Called in saveAsParquet after saving RDD to Parquet to save metadata.

    Called in saveAsParquet after saving RDD to Parquet to save metadata.

    Writes any necessary metadata to disk. If not overridden, writes the sequence dictionary to disk as Avro.

    filePath

      The filepath to the file where we will save the Metadata.

    Attributes
      protected
    Definition Classes
      AvroRecordGroupGenomicRDD → AvroGenomicRDD

84. #### def savePartitionMap(filePath: String): Unit

    Save the partition map to disk.

    Save the partition map to disk. This is done by adding the partition map to the schema.

    filePath

      The filepath where we will save the partition map.

    Attributes
      protected
    Definition Classes
      AvroGenomicRDD

85. #### def saveProcessingSteps(filePath: String): Unit

    Save the processing steps to disk.

    Save the processing steps to disk.

    filePath

      The filepath to the directory within which we will save the processing step descriptions..

    Attributes
      protected
    Definition Classes
      AvroRecordGroupGenomicRDD

86. #### def saveRddAsParquet(pathName: String, blockSize: Int = 128 * 1024 * 1024, pageSize: Int = 1 * 1024 * 1024, compressCodec: CompressionCodecName = CompressionCodecName.GZIP, disableDictionaryEncoding: Boolean = false, optSchema: Option[Schema] = None): Unit

    Saves an RDD of Avro data to Parquet.

    Saves an RDD of Avro data to Parquet.

    pathName

      The path to save the file to.

    blockSize

      The size in bytes of blocks to write. Defaults to 128 * 1024 * 1024.

    pageSize

      The size in bytes of pages to write. Defaults to 1 * 1024 * 1024.

    compressCodec

      The compression codec to apply to pages. Defaults to CompressionCodecName.GZIP.

    disableDictionaryEncoding

      If false, dictionary encoding is used. If true, delta encoding is used. Defaults to false.

    optSchema

      The optional schema to set. Defaults to None.

    Attributes
      protected
    Definition Classes
      ADAMRDDFunctions

87. #### def saveRddAsParquet(args: SaveArgs): Unit

    Attributes
      protected
    Definition Classes
      ADAMRDDFunctions

88. #### def saveRecordGroups(filePath: String): Unit

    Save the record groups to disk.

    Save the record groups to disk.

    filePath

      The filepath to the file where we will save the record groups.

    Attributes
      protected
    Definition Classes
      AvroRecordGroupGenomicRDD

89. #### def saveSequences(filePath: String): Unit

    Save the sequence dictionary to disk.

    Save the sequence dictionary to disk.

    filePath

      The filepath where we will save the sequence dictionary.

    Attributes
      protected
    Definition Classes
      AvroGenomicRDD

90. #### val sequences: SequenceDictionary

    The sequence dictionary describing the reference assembly this dataset is aligned to.

    The sequence dictionary describing the reference assembly this dataset is aligned to.

    Definition Classes
      ParquetUnboundFragmentRDD → GenomicRDD

91. #### def shuffleRegionJoin[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], txTag: ClassTag[(Fragment, X)]): GenericGenomicRDD[(Fragment, X)]

    Performs a sort-merge inner join between this RDD and another RDD.

    Performs a sort-merge inner join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicRDD

92. #### def shuffleRegionJoin[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y], flankSize: Long)(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], txTag: ClassTag[(Fragment, X)]): GenericGenomicRDD[(Fragment, X)]

    Performs a sort-merge inner join between this RDD and another RDD.

    Performs a sort-merge inner join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicRDD

93. #### def shuffleRegionJoinAndGroupByLeft[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], tixTag: ClassTag[(Fragment, Iterable[X])]): GenericGenomicRDD[(Fragment, Iterable[X])]

    Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

    Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. In the same operation, we group all values by the left item in the RDD.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD..

    Definition Classes
      GenomicRDD

94. #### def shuffleRegionJoinAndGroupByLeft[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y], flankSize: Long)(implicit tTag: ClassTag[Fragment], xTag: ClassTag[X], tixTag: ClassTag[(Fragment, Iterable[X])]): GenericGenomicRDD[(Fragment, Iterable[X])]

    Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

    Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. In the same operation, we group all values by the left item in the RDD.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD..

    Definition Classes
      GenomicRDD

95. #### def sort(partitions: Int = rdd.partitions.length, stringency: ValidationStringency = ValidationStringency.STRICT)(implicit tTag: ClassTag[Fragment]): FragmentRDD

    Sorts our genome aligned data by reference positions, with contigs ordered by index.

    Sorts our genome aligned data by reference positions, with contigs ordered by index.

    partitions

      The number of partitions for the new RDD.

    stringency

      The level of ValidationStringency to enforce.

    returns

      Returns a new RDD containing sorted data.

    Definition Classes
      GenomicRDD
    Note

      Uses ValidationStringency to handle unaligned or where objects align to multiple positions.

    See also

      sortLexicographically

96. #### def sort(): FragmentRDD

    Sorts our genome aligned data by reference positions, with contigs ordered by index.

    Sorts our genome aligned data by reference positions, with contigs ordered by index.

    returns

      Returns a new RDD containing sorted data.

    Definition Classes
      GenomicRDD
    See also

      sortLexicographically

97. #### def sortLexicographically(partitions: Int = rdd.partitions.length, storePartitionMap: Boolean = false, storageLevel: StorageLevel = StorageLevel.MEMORY_ONLY, stringency: ValidationStringency = ValidationStringency.STRICT)(implicit tTag: ClassTag[Fragment]): FragmentRDD

    Sorts our genome aligned data by reference positions, with contigs ordered lexicographically.

    Sorts our genome aligned data by reference positions, with contigs ordered lexicographically.

    partitions

      The number of partitions for the new RDD.

    storePartitionMap

      A Boolean flag to determine whether to store the partition bounds from the resulting RDD.

    storageLevel

      The level at which to persist the resulting RDD.

    stringency

      The level of ValidationStringency to enforce.

    returns

      Returns a new RDD containing sorted data.

    Definition Classes
      GenomicRDD
    Note

      Uses ValidationStringency to handle data that is unaligned or where objects align to multiple positions.

    See also

      sort

98. #### def sortLexicographically(): FragmentRDD

    Sorts our genome aligned data by reference positions, with contigs ordered lexicographically.

    Sorts our genome aligned data by reference positions, with contigs ordered lexicographically.

    returns

      Returns a new RDD containing sorted data.

    Definition Classes
      GenomicRDD
    See also

      sort

99. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

100. #### def toDF(): DataFrame

     returns

       This data as a Spark SQL DataFrame.

     Definition Classes
       GenomicDataset

101. #### def toReads(): AlignmentRecordRDD

     Essentially, splits up the reads in a Fragment.

     Essentially, splits up the reads in a Fragment.

     returns

       Returns this RDD converted back to reads.

     Definition Classes
       FragmentRDD

102. #### def toString(): String

     Definition Classes
       AvroRecordGroupGenomicRDD → GenomicRDD → AnyRef → Any

103. #### def transform(tFn: Function[JavaRDD[Fragment], JavaRDD[Fragment]]): FragmentRDD

     Applies a function that transforms the underlying RDD into a new RDD.

     Applies a function that transforms the underlying RDD into a new RDD.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

     Definition Classes
       GenomicRDD

104. #### def transform(tFn: (RDD[Fragment]) ⇒ RDD[Fragment]): FragmentRDD

     Applies a function that transforms the underlying RDD into a new RDD.

     Applies a function that transforms the underlying RDD into a new RDD.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

     Definition Classes
       GenomicRDD

105. #### def transformDataFrame(tFn: Function[DataFrame, DataFrame]): FragmentRDD

     Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API.

     Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API. Java-friendly variant.

     tFn

       A function that transforms the underlying RDD as a DataFrame.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

     Definition Classes
       GenomicDataset

106. #### def transformDataFrame(tFn: (DataFrame) ⇒ DataFrame)(implicit uTag: scala.reflect.api.JavaUniverse.TypeTag[Fragment]): FragmentRDD

     Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API.

     Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API.

     tFn

       A function that transforms the underlying RDD as a DataFrame.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

     Definition Classes
       GenomicDataset

107. #### def transformDataset(tFn: (Dataset[Fragment]) ⇒ Dataset[Fragment]): FragmentRDD

     Applies a function that transforms the underlying RDD into a new RDD using the Spark SQL API.

     Applies a function that transforms the underlying RDD into a new RDD using the Spark SQL API.

     tFn

       A function that transforms the underlying RDD as a Dataset.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

     Definition Classes
       FragmentRDD → GenomicDataset

108. #### def transmute[X, Y <: GenomicRDD[X, Y]](tFn: Function[JavaRDD[Fragment], JavaRDD[X]], convFn: Function2[FragmentRDD, RDD[X], Y]): Y

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     Applies a function that transmutes the underlying RDD into a new RDD of a different type. Java friendly version.

     tFn

       A function that transforms the underlying RDD.

     convFn

       The conversion function used to build the final RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

     Definition Classes
       GenomicRDD

109. #### def transmute[X, Y <: GenomicRDD[X, Y]](tFn: (RDD[Fragment]) ⇒ RDD[X])(implicit convFn: (FragmentRDD, RDD[X]) ⇒ Y): Y

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

     Definition Classes
       GenomicRDD

110. #### def transmuteDataFrame[X <: Product, Y <: GenomicDataset[_, X, Y]](tFn: Function[DataFrame, DataFrame], convFn: GenomicDatasetConversion[Fragment, FragmentRDD, X, Y]): Y

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     Applies a function that transmutes the underlying RDD into a new RDD of a different type. Java friendly variant.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

     Definition Classes
       GenomicDataset

111. #### def transmuteDataFrame[X <: Product, Y <: GenomicDataset[_, X, Y]](tFn: (DataFrame) ⇒ DataFrame)(implicit xTag: scala.reflect.api.JavaUniverse.TypeTag[X], convFn: (FragmentRDD, Dataset[X]) ⇒ Y): Y

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     Applies a function that transmutes the underlying RDD into a new RDD of a different type. Java friendly variant.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

     Definition Classes
       GenomicDataset

112. #### def transmuteDataset[X <: Product, Y <: GenomicDataset[_, X, Y]](tFn: Function[Dataset[Fragment], Dataset[X]], convFn: GenomicDatasetConversion[Fragment, FragmentRDD, X, Y]): Y

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     Applies a function that transmutes the underlying RDD into a new RDD of a different type. Java friendly variant.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

     Definition Classes
       GenomicDataset

113. #### def transmuteDataset[X <: Product, Y <: GenomicDataset[_, X, Y]](tFn: (Dataset[Fragment]) ⇒ Dataset[X])(implicit xTag: scala.reflect.api.JavaUniverse.TypeTag[X], convFn: (FragmentRDD, Dataset[X]) ⇒ Y): Y

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

     Definition Classes
       GenomicDataset

114. #### val uTag: scala.reflect.api.JavaUniverse.TypeTag[Fragment]

     Definition Classes
       FragmentRDD → GenomicDataset

115. #### def union(rdds: FragmentRDD*): FragmentRDD

     Unions together multiple genomic RDDs.

     Unions together multiple genomic RDDs.

     rdds

       RDDs to union with this RDD.

     Definition Classes
       FragmentRDD → GenomicRDD

116. #### def union(rdds: List[FragmentRDD]): FragmentRDD

     Unions together multiple genomic RDDs.

     Unions together multiple genomic RDDs.

     rdds

       RDDs to union with this RDD.

     Definition Classes
       GenomicRDD

117. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

118. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

119. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

120. #### def writeTextRdd[T](rdd: RDD[T], outputPath: String, asSingleFile: Boolean, disableFastConcat: Boolean, optHeaderPath: Option[String] = None): Unit

     Writes an RDD to disk as text and optionally merges.

     Writes an RDD to disk as text and optionally merges.

     rdd

       RDD to save.

     outputPath

       Output path to save text files to.

     asSingleFile

       If true, combines all partition shards.

     disableFastConcat

       If asSingleFile is true, disables the use of the parallel file merging engine.

     optHeaderPath

       If provided, the header file to include.

     Attributes
       protected
     Definition Classes
       GenomicRDD

### Inherited from Product

### Inherited from Equals

### Inherited from FragmentRDD

### Inherited from AvroRecordGroupGenomicRDD[Fragment, Fragment, FragmentRDD]

### Inherited from GenomicRDDWithLineage[Fragment, FragmentRDD]

### Inherited from AvroGenomicRDD[Fragment, Fragment, FragmentRDD]

### Inherited from GenomicDataset[Fragment, Fragment, FragmentRDD]

### Inherited from GenomicRDD[Fragment, FragmentRDD]

### Inherited from ADAMRDDFunctions[Fragment]

### Inherited from Logging

### Inherited from Serializable

### Inherited from AnyRef

### Inherited from Any

### Ungrouped